#include <bits/stdc++.h>

using namespace std;

#define int long long
#define MAXN 1001

int n,k;
vector<pair<int,int>> vec;
int answer[MAXN];

int32_t main()
{
    cin>>n>>k;
    for (int i=1;i<=k;i++) {int x;cin>>x;vec.push_back({x,i});}
    sort(vec.begin(),vec.end());
    if (n<=1000)
    {
        for (int i=0;i<k;i++)
        {
            int num=vec[i].first,poz=vec[i].second;
            for (int j=0;j<k;j++)
            {
                if (num%vec[j].first==0) answer[poz]^=vec[j].first;
            }
        }
        for (int i=1;i<=k;i++) cout<<answer[i]<<" ";
        cout<<endl;return 0;
    }
    return 0;
}